c
c     =====================================================
      subroutine mapc2p(xc,yc,xp,yp)
c     =====================================================
c
c     # on input,  (xc,yc) is a computational grid point
c     # on output, (xp,yp) is corresponding point in physical space
c
c     # map the square [-1,1] x [-1,1] to the unit circle
c     # as described in Section 3.1 of
c     #   Logically Rectangular Grids and Finite Volume Methods for PDEs
c     #       in Circular and Spherical Domains,
c     #   by Donna A. Calhoun, Christiane Helzel, and Randall J. LeVeque,
c     #   http://www.amath.washington.edu/~rjl/pubs/circles
c
      implicit double precision (a-h,o-z)
c
c     # radial projection mapping
      r1 = 1.d0
      d = dmax1(dabs(xc), dabs(yc))
      r = dmax1(dsqrt(xc**2 + yc**2), 1.d-10)
      xp = r1*d*xc/r
      yp = r1*d*yc/r

      return
      end
