c
c     =====================================================
      subroutine mapc2p(xc,yc,xp,yp)
c     =====================================================
c
c     # on input,  (xc,yc) is a computational grid point
c     # on output, (xp,yp) is corresponding point in physical space
c
c     # map the square [-1,1] x [-1,1] to the starlike domain
c     # using mapping from Fig 3.2(b) from
c     #   Logically Rectangular Grids and Finite Volume Methods for PDEs
c     #       in Circular and Spherical Domains,
c     #   by Donna A. Calhoun, Christiane Helzel, and Randall J. LeVeque,
c     #   http://www.amath.washington.edu/~rjl/pubs/circles
c
      implicit double precision (a-h,o-z)
c
c
      xc1 = dmax1(dabs(xc), 1d-10)
      yc1 = dmax1(dabs(yc), 1d-10)

      d = dmax1(dmax1(xc1,yc1), 1.d-10)
      d1 = d / dsqrt(2.d0)
      R = 1.d0 
      center = d1 - dsqrt(R**2 - d1**2)

      if (xc1.eq.d) then
          yp = d1/d * yc1
          xp = center + dsqrt(R**2 - yp**2)
      else 
          xp = d1/d * xc1
          yp = center + dsqrt(R**2 - xp**2)
      endif

      xp = dsign(xp,xc)
      yp = dsign(yp,yc)

      return
      end
