#!/usr/bin/env python 

# Requires numpy and matplotlib from pylab:
from pylab import *

def plotgrid(n=40):
    # Plots an n by n grid of quadrilateral defined by mapping the
    # square [-1,1] x [-1,1] using the mapc2p function in this directory.
    
    import mapc2p          # this should define function mapc2p
    
    [xc,yc] = meshgrid(linspace(-1,1,n+1), linspace(-1,1,n+1))
    [xp,yp] = mapc2p.mapc2p(xc,yc)
    clf()
    hold(True)
    for i in range(n+1):
        plot(xp[i,:], yp[i,:], 'k')
        plot(xp[:,i], yp[:,i], 'k')
    gca().set_aspect('equal')
    axis([-1.2,1.2,-1.2,1.2])
    
    fname = 'grid.png'
    savefig(fname)
    print 'Saved figure to ', fname
    
if __name__ == '__main__':
    # if executed from command line:
    plotgrid(40)
