if (PlotType == 4)
  xlabel('Radius','fontsize',14);
  ylabel('\rho(r)','fontsize',14);
  str = get(gca,'title');
  set(str,'fontsize',18);
  axis([0 1 0 2.1]);
end

if (PlotType == 1)
  % For contour lines on the right half.
  cv = ContourValues;

  % Now plot left half using results from radial mapping.
  hold on;
  dir = './output_radial/';
  [amr2d,t2d] = readamrdata(2,Frame,dir);
  if (isempty(amr2d))
    fprintf('Files not available\n');
  elseif (abs(t - t2d) > 1e-12)
    fprintf('Times are not compatible\n');
  else
    % Flip x axis for plotting
    for i = 1:length(amr2d)
      amr2d(i).dx = -amr2d(i).dx;
      amr2d(i).xlow = -amr2d(i).xlow;
    end;
    plottype = 1;
    if UserVariable == 1
      uf = UserVariableFile;
    else
      uf = '';
    end;

    % Set global variable needed by mapping routine
    map_choice = map_choice2;
    q2d  = plotframe2ez(amr2d,mq,plottype,'z',0,cv,uf,'mapc2p');
    map_choice = map_choice1;


    % Add text, etc to plot.
    txth(1) = text(0.45,0.75,'Convex mapping');
    txth(2) = text(-1.25,0.75,'Radial projection');
    set(txth,'fontsize',14,'fontweight','bold');
  end;
  hidegridlines
  showpatchborders;
  title(sprintf('t = %5.2f',t),'fontsize',18);
  set(gca,'fontsize',14);

  setslicecolor('none');
  axis([-1 1.0 -1 1])
  daspect([1 1 1]);

  axis off;
  hold off;
end;

clear mapc2p;
clear afterframe
