      subroutine setprob
      implicit none

c     #
c     # Setup of initial molar fractions.  Indices refer to
c     # chemical species in the order (H2, H2O, N2, and O2),

      double precision rho1, p1, rho2, p2, v1, v2
      double precision gamma,gamma1
      double precision x0, y0, r0
      double precision alpha, pi, r1
      integer map_choice

      common /param/ gamma, gamma1
      common /cominit1/ p1, v1, rho1
      common /cominit2/ p2, v2, rho2
      common /cominit3/ x0, y0, r0
      common /compi/ pi
      common /mapparm/ alpha, r1
      common /mapchoice/ map_choice

      pi = 4.d0*atan(1.d0)

      open(unit=7,file='setprob.data')

c     # u1 : initial velocity
      read(7,*) gamma
      read(7,*) rho1, p1
      read(7,*) rho2, p2
      read(7,*) x0, y0, r0
      read(7,*) alpha
      read(7,*) r1
      read(7,*) map_choice
      close(7)

c     # Set up other parameters
      gamma1 = gamma-1

      v1 = 0.d0
      v2 = 0.d0

      write(6,'(A)') 'Right states '
      write(6,'(A)') '----------------------------------'
      write(6,100) 'rho1      ', rho1
      write(6,100) 'v1        ', v1
      write(6,100) 'p1        ', p1
      write(6,*) ' '

      write(6,'(A)') 'Left states'
      write(6,'(A)') '----------------------------------'
      write(6,100) 'rho2      ', rho2
      write(6,100) 'v2        ', v2
      write(6,100) 'p2        ', p2
      write(6,*) ' '

  100 format(A,F24.16)

      return
      end
